<?
//Query

//loading the php mapscript module
if (!extension_loaded( "mapscript" ))
    dl ("php_mapscript_42.dll" );

//loading DBF module
define( "DBF_MODULE", "php_dbase.".PHP_SHLIB_SUFFIX );
if (!extension_loaded( "dbase" ))
    dl (DBF_MODULE );

// the global map object
$GLOBALS["goMap"] = ms_newMapObj("../data/tutorial.map" );

// determine a suitable image format.
if (strpos( ms_GetVersion(), "OUTPUT=GIF") > 0 )
  $GLOBALS["goMap"]->selectOutputFormat("gif");
else
  $GLOBALS["goMap"]->selectOutputFormat("png");

//the full extents.
//NOTE: using $val = $oMap->extent->minx is a reference, not a value.
$GLOBALS["gfMinX"] = (float)$GLOBALS["goMap"]->extent->minx;
$GLOBALS["gfMinY"] = (float)$GLOBALS["goMap"]->extent->miny;
$GLOBALS["gfMaxX"] = (float)$GLOBALS["goMap"]->extent->maxx;
$GLOBALS["gfMaxY"] = (float)$GLOBALS["goMap"]->extent->maxy;

// determine a suitable image format.
if (strpos( ms_GetVersion(), "OUTPUT=GIF") > 0 )
  $GLOBALS["goMap"]->selectOutputFormat("gif");
else
  $GLOBALS["goMap"]->selectOutputFormat("png");

//select from the available URL arrays
$aVars = (sizeof($_POST) > 0) ? $_POST : (sizeof($_GET) > 0) ? $_GET : array();

$GLOBALS["gszCurrentTool"] = "ZOOM_IN";


$GLOBALS["gShowQueryResults"] = FALSE;

ProcessURLArray( $aVars );

//call to function to add the layer
AddDynamicLayer();

/*
 * DrawMap()
 * renders some HTML that represents the map image.
 */
function DrawMap()
{

    if ($GLOBALS["gShowQueryResults"])
        $img = $GLOBALS["goMap"]->drawQuery();
    else
      $img = $GLOBALS["goMap"]->draw();

    $url = $img->saveWebImage();

    $nWidth = $GLOBALS["goMap"]->width;
    $nHeight = $GLOBALS["goMap"]->height;

    echo"<INPUT  TYPE=image SRC=".$url." BORDER=0 WIDTH=\"".
        $nWidth."\" HEIGHT=\"".$nHeight."\" NAME=MAINMAP>\n";

    echo "<INPUT TYPE=HIDDEN NAME=MINX VALUE=\"".
         $GLOBALS["goMap"]->extent->minx."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MINY VALUE=\"".
         $GLOBALS["goMap"]->extent->miny."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MAXX VALUE=\"".
         $GLOBALS["goMap"]->extent->maxx."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MAXY VALUE=\"".
         $GLOBALS["goMap"]->extent->maxy."\">\n";
}

/*
 * DrawKeyMap()
 * renders some HTML that represents the Reference object
 */
function DrawKeyMap()
{
    $img = $GLOBALS["goMap"]->drawreferencemap();
    $url = $img->saveWebImage();

    echo "<INPUT TYPE=image SRC=$url  BORDER=0 NAME=KEYMAP>\n";
}

/*
 * DrawScaleBar()
 * render some HTML to represent the scalebar object
 */
function DrawScaleBar()
{
    $img = $GLOBALS["goMap"]->drawScaleBar();
    $url = $img->saveWebImage();

    echo"<IMG SRC=$url BORDER=0>\n";
}

function DrawLegend()
{
    $img = $GLOBALS["goMap"]->drawLegend();
    $url = $img->saveWebImage();

    echo"<IMG SRC=$url BORDER=0>\n";
}
/*
 * DrawLegend()
 * render some HTML to represent the legend object
 */
function DrawHTMLLegend()
{
    echo "<table cellspacing=0 cellpadding=0>";
    echo "<tr bgcolor=\"#E2EFF5\">\n";
    echo "<td></td>\n";
    echo "<td></td>\n";
    echo "</tr>\n";
    echo $GLOBALS["goMap"]->processLegendTemplate( array() );
    echo "<tr>\n";
    echo "<td><input type=\"image\" src=\"./images/icon_update.png\" width=\"20\" height=\"20\"></td>\n";
    echo "<td colspan=2><font face=\"Arial,Helvetica,sans-serif\" size=\"2\">Update</td>\n";
    echo "</tr>\n";
    echo "</table>";
   
}

/*
 * DrawQueryResults()
 * render some HTML to represent the query object
 */
function DrawQueryResults()
{
  if (!$GLOBALS["gShowQueryResults"])
    echo "&nbsp;";
    else
    {
        
        $sTemplate = $GLOBALS["goMap"]->processquerytemplate(array(), 0);
        echo $sTemplate;

    }
}

/*
 * ProcessURLArray()
 * test an array of values and take action as necessary
 */
/*
 * ProcessURLArray()
 * test an array of values and take action as necessary
 */
function ProcessURLArray( $aVars)
{
    //record the current command
    $GLOBALS["gszCurrentTool"] = (isset($aVars["CMD"])) ? $aVars["CMD"] : "ZOOM_IN";

    //set up the previous extents
    $oExt = $GLOBALS["goMap"];
    $fMinX = isset($aVars["MINX"]) ? $aVars["MINX"] : $oExt->extent->minx;
    $fMinY = isset($aVars["MINY"]) ? $aVars["MINY"] : $oExt->extent->miny;;
    $fMaxX = isset($aVars["MAXX"]) ? $aVars["MAXX"] : $oExt->extent->maxx;;
    $fMaxY = isset($aVars["MAXY"]) ? $aVars["MAXY"] : $oExt->extent->maxy;;

    $GLOBALS["goMap"]->setextent( $fMinX, $fMinY, $fMaxX, $fMaxY );

    //some short cuts
    $fWidthPix  = $GLOBALS["goMap"]->width;
    $fHeightPix = $GLOBALS["goMap"]->height;

    
    //process layer visibility
    if (isset($_GET["legendlayername"]))
    {
        for( $i=0; $i<$GLOBALS["goMap"]->numlayers; $i++ )
        {
            $oLayer = $GLOBALS["goMap"]->getLayer($i);
            if (in_array( $oLayer->name, $_GET["legendlayername"] ))
                $oLayer->set( "status", MS_ON );
            else
                $oLayer->set( "status", MS_OFF );
        }
    }

    //process commands
    if (isset($aVars["CMD"]) && isset ($aVars["MAINMAP_x"]))
    {
        //determine where to navigate to.
        $nX = isset($aVars["MAINMAP_x"]) ? intval($aVars["MAINMAP_x"]) :
                                           $fWidthPix/2.0;
        $nY = isset($aVars["MAINMAP_y"]) ? intval($aVars["MAINMAP_y"]) :
                                           $fWidthPix/2.0;
        if (isset($aVars["MAINMAP_x"]) && isset($aVars["MAINMAP_y"]))
        {

            $oPixelPos = ms_newpointobj();
            $oPixelPos->setxy($nX, $nY);

            $oGeorefExt = ms_newrectobj();
            $oGeorefExt->setextent($fMinX, $fMinY, $fMaxX, $fMaxY);

            if ($aVars["CMD"] == "ZOOM_IN")
            {
                $GLOBALS["goMap"]->zoompoint(2, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "ZOOM_OUT")
            {
                $GLOBALS["goMap"]->zoompoint(-2, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "RECENTER")
            {
                $GLOBALS["goMap"]->zoompoint(1, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "ZOOM_FULL")
            {
                $GLOBALS["goMap"]->setextent($GLOBALS["gfMinX"],$GLOBALS["gfMinY"],
                                             $GLOBALS["gfMaxX"],$GLOBALS["gfMaxY"]);
            }
            else if ($aVars["CMD"] == "QUERY")
            {
                $nGeoX = Pix2Geo($nX, 0, $fWidthPix,
                              $fMinX, $fMaxX, 0);
                $nGeoY = Pix2Geo($nY, 0, $fHeightPix,
                              $fMinY, $fMaxY, 1);

                $oGeo = ms_newPointObj();
                $oGeo->setXY($nGeoX, $nGeoY);

                // Use '@' to avoid warning if query found nothing
                @$GLOBALS["goMap"]->queryByPoint($oGeo, MS_MULTIPLE, -1);

                $GLOBALS["gShowQueryResults"] = TRUE;

            }
        }
    }
    else if (isset($aVars["KEYMAP_x"]) && isset($aVars["KEYMAP_y"]))
    {
      $oRefExt = $GLOBALS["goMap"]->reference->extent;
      
      $nX = intval($aVars["KEYMAP_x"]);
      $nY = intval($aVars["KEYMAP_y"]);
      
      $fWidthPix = doubleval($GLOBALS["goMap"]->reference->width);
      $fHeightPix = doubleval($GLOBALS["goMap"]->reference->height);
      
      $nGeoX = Pix2Geo($nX, 0, $fWidthPix, $oRefExt->minx, $oRefExt->maxx, 0);
      $nGeoY = Pix2Geo($nY, 0, $fHeightPix, $oRefExt->miny, $oRefExt->maxy, 1);
      
      $fDeltaX = ($fMaxX - $fMinX) / 2.0;
      $fDeltaY = ($fMaxY - $fMinY) / 2.0;
      
      $GLOBALS["goMap"]->setextent($nGeoX - $fDeltaX, $nGeoY - $fDeltaY,
                                   $nGeoX + $fDeltaX, $nGeoY + $fDeltaY);
    }

}   


function IsCurrentTool( $szTool )
{
    return (strcasecmp($GLOBALS["gszCurrentTool"], $szTool) == 0);
}


/*
 * Pix2Geo()
 * convert a pixel position to a geographic position
 *
 * nPixPos is the pixel position (x or y) to convert
 * dfPixMin, dfPixMax are the pixel extents to convert within (image size)
 * dfGeoMin, dfGeoMax are the geographic extents to convert with
 * bInversePix is true if the upper left corner is bigger than the
 *             lower right corner for y coordinates.
 */
function Pix2Geo($nPixPos, $fPixMin, $fPixMax, $fGeoMin, $fGeoMax,
                     $bInversePix)
{
    $fDeltaPix = ($bInversePix) ? $fPixMax - $nPixPos : $nPixPos - $fPixMin;

    $fDeltaGeo = $fDeltaPix * ($fGeoMax - $fGeoMin) / ($fPixMax - $fPixMin);

    return $fGeoMin + $fDeltaGeo;
}


/*
 * CreateLayer()
 */
function CreateLayer($szDataName)
{
    $oMap = $GLOBALS["goMap"];
    //create layer and set members
    $oLayer = ms_newLayerObj($oMap);
    $oLayer->set("name", "canada_cities");
    $oLayer->set("status", MS_ON);
    $oLayer->set("data", $szDataName);
    $oLayer->set("type", MS_LAYER_POINT);

    $oLayer->setMetaData("DESCRIPTION", "New Cities Layer");
    

    //projection is latlong
    $oLayer->setProjection("init=epsg:4326");

    $oLayer->set("labelitem", "NAME");
    $oLayer->set("classitem", "CAPITAL");


    //Country capital
    //create class
    $oClass = ms_newClassObj($oLayer);

    $oClass->set("name", "Capital");
        $oClass->setexpression("/1/");

    //create style
    $oStyle = ms_newStyleObj($oClass);
    $oStyle->set("symbol", 2);
    $oStyle->set("size", 8);
    $oStyle->color->setRGB(255, 0, 0);

    //set label object
    $oClass->label->set("font", "fritqat-italic");
    $oClass->label->set("type", MS_TRUETYPE);
    $oClass->label->set("size", 8);
    $oClass->label->color->setRGB(255, 0 , 0);
    $oClass->label->set("position", MS_AUTO);
    $oClass->label->set("partials", MS_FALSE);

    //provincial capitals
    $oClass = ms_newClassObj($oLayer);
    $oClass->set("name", "Provincial Capital");
    $oClass->setexpression("/2|3/");

    $oStyle = ms_newStyleObj($oClass);
    $oStyle->set("symbol", 7);
    $oStyle->set("size", 6);
    $oStyle->color->setRGB(0, 0, 0);

    //set label object
    $oClass->label->set("font", "fritqat");
    $oClass->label->set("type", MS_TRUETYPE);
    $oClass->label->set("size", 8);
    $oClass->label->color->setRGB(0, 0 , 0);
    $oClass->label->set("position", MS_AUTO);
    $oClass->label->set("partials", MS_FALSE);
}
/*
 * AddDynamicLayer()
 */
function AddDynamicLayer()
{
    //Creating the shapefiles
    $oMap = $GLOBALS["goMap"];
    $szFileName = $oMap->web->imagepath . uniqid("");
    $oShapFile = ms_newShapeFileObj($szFileName, MS_SHP_POINT);

    //create a new DBF attached with few attributes
    $hDbf = dbase_create($szFileName.".dbf",
                         array(array("POP_RANGE", "N", 5, 0),
                               array("NAME", "C", 50, 0),
                               array("CAPITAL", "N", 5, 0)));
    if (!$hDbf)
      return;

    //open the original dbf file
    $szOrginalDbfName = "../data/canada_cities.dbf";
    $hOrigDbf = dbase_open($szOrginalDbfName, 0);
    if (!$hOrigDbf)
      return;

    $nRecords = dbase_numrecords($hOrigDbf);
    for ($i=1; $i<=$nRecords; $i++)
    {
        //retreive field attributes
        $aRecord = dbase_get_record_with_names($hOrigDbf, $i);
        $dfLat = floatval($aRecord["LAT"]);
        $dfLong = floatval($aRecord["LONG"]);
        $nPopRange = intval($aRecord["POP_RANGE"]);
        $szName = strval($aRecord["NAME"]);
        $nCapital = intval($aRecord["CAPITAL"]);

        //create a point for each record and add it to the shapefile
        $oShp = ms_newShapeObj(MS_SHP_POINT);
        $oLine = ms_newLineObj();
        $oLine->addXY($dfLong, $dfLat);
        $oShp->add( $oLine );
        $oShapFile->addShape($oShp);

        //add a record to the DBF
        $aAttValues[0] = $nPopRange;
        $aAttValues[1] = $szName;
        $aAttValues[2] = $nCapital;
        dbase_add_record($hDbf, $aAttValues);
        $oShp->free();
    }
    dbase_close($hOrigDbf);

    dbase_close($hDbf);
    $oShapFile->free();

    //Add a new layer in the map
    CreateLayer($szFileName);
}
