<?
//Key map navigation

//loading the php mapscript module
if (!extension_loaded( "mapscript" ))
    dl ("php_mapscript_42.dll" );

// the global map object
$GLOBALS["goMap"] = ms_newMapObj("../data/tutorial.map" );

// determine a suitable image format.
if (strpos( ms_GetVersion(), "OUTPUT=GIF") > 0 )
  $GLOBALS["goMap"]->selectOutputFormat("gif");
else
  $GLOBALS["goMap"]->selectOutputFormat("png");

//the full extents.
//NOTE: using $val = $oMap->extent->minx is a reference, not a value.
$GLOBALS["gfMinX"] = (float)$GLOBALS["goMap"]->extent->minx;
$GLOBALS["gfMinY"] = (float)$GLOBALS["goMap"]->extent->miny;
$GLOBALS["gfMaxX"] = (float)$GLOBALS["goMap"]->extent->maxx;
$GLOBALS["gfMaxY"] = (float)$GLOBALS["goMap"]->extent->maxy;

// determine a suitable image format.
if (strpos( ms_GetVersion(), "OUTPUT=GIF") > 0 )
  $GLOBALS["goMap"]->selectOutputFormat("gif");
else
  $GLOBALS["goMap"]->selectOutputFormat("png");

//select from the available URL arrays
$aVars = (sizeof($_POST) > 0) ? $_POST : (sizeof($_GET) > 0) ? $_GET : array();

$GLOBALS["gszCurrentTool"] = "ZOOM_IN";

ProcessURLArray( $aVars );

/*
 * DrawMap()
 * renders some HTML that represents the map image.
 */
function DrawMap()
{
    $img = $GLOBALS["goMap"]->draw();
    $url = $img->saveWebImage();

    $nWidth = $GLOBALS["goMap"]->width;
    $nHeight = $GLOBALS["goMap"]->height;

    echo"<INPUT  TYPE=image SRC=".$url." BORDER=0 WIDTH=\"".
        $nWidth."\" HEIGHT=\"".$nHeight."\" NAME=MAINMAP>\n";

    echo "<INPUT TYPE=HIDDEN NAME=MINX VALUE=\"".
         $GLOBALS["goMap"]->extent->minx."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MINY VALUE=\"".
         $GLOBALS["goMap"]->extent->miny."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MAXX VALUE=\"".
         $GLOBALS["goMap"]->extent->maxx."\">\n";
    echo "<INPUT TYPE=HIDDEN NAME=MAXY VALUE=\"".
         $GLOBALS["goMap"]->extent->maxy."\">\n";
}

/*
 * DrawKeyMap()
 * renders some HTML that represents the Reference object
 */
function DrawKeyMap()
{
    $img = $GLOBALS["goMap"]->drawreferencemap();
    $url = $img->saveWebImage();

    echo "<INPUT TYPE=image SRC=$url  BORDER=0 NAME=KEYMAP>\n";
}

/*
 * DrawScaleBar()
 * render some HTML to represent the scalebar object
 */
function DrawScaleBar()
{
    $img = $GLOBALS["goMap"]->drawScaleBar();
    $url = $img->saveWebImage();

    echo"<IMG SRC=$url BORDER=0>\n";
}

/*
 * DrawLegend()
 * render some HTML to represent the legend object
 */
function DrawLegend()
{
    echo "Legend here!";
}

/*
 * DrawQueryResults()
 * render some HTML to represent the query object
 */
function DrawQueryResults()
{
    echo "Query Results: not yet!";
}

/*
 * ProcessURLArray()
 * test an array of values and take action as necessary
 */
/*
 * ProcessURLArray()
 * test an array of values and take action as necessary
 */
function ProcessURLArray( $aVars)
{
    //record the current command
    $GLOBALS["gszCurrentTool"] = (isset($aVars["CMD"])) ? $aVars["CMD"] : "ZOOM_IN";

    //set up the previous extents
    $oExt = $GLOBALS["goMap"];
    $fMinX = isset($aVars["MINX"]) ? $aVars["MINX"] : $oExt->extent->minx;
    $fMinY = isset($aVars["MINY"]) ? $aVars["MINY"] : $oExt->extent->miny;;
    $fMaxX = isset($aVars["MAXX"]) ? $aVars["MAXX"] : $oExt->extent->maxx;;
    $fMaxY = isset($aVars["MAXY"]) ? $aVars["MAXY"] : $oExt->extent->maxy;;

    $GLOBALS["goMap"]->setextent( $fMinX, $fMinY, $fMaxX, $fMaxY );

    //some short cuts
    $fWidthPix  = $GLOBALS["goMap"]->width;
    $fHeightPix = $GLOBALS["goMap"]->height;

    //process commands
    if (isset($aVars["CMD"]) && isset ($aVars["MAINMAP_x"]))
    {
        //determine where to navigate to.
        $nX = isset($aVars["MAINMAP_x"]) ? intval($aVars["MAINMAP_x"]) :
                                           $fWidthPix/2.0;
        $nY = isset($aVars["MAINMAP_y"]) ? intval($aVars["MAINMAP_y"]) :
                                           $fWidthPix/2.0;
        if (isset($aVars["MAINMAP_x"]) && isset($aVars["MAINMAP_y"]))
        {

            $oPixelPos = ms_newpointobj();
            $oPixelPos->setxy($nX, $nY);

            $oGeorefExt = ms_newrectobj();
            $oGeorefExt->setextent($fMinX, $fMinY, $fMaxX, $fMaxY);

            if ($aVars["CMD"] == "ZOOM_IN")
            {
                $GLOBALS["goMap"]->zoompoint(2, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "ZOOM_OUT")
            {
                $GLOBALS["goMap"]->zoompoint(-2, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "RECENTER")
            {
                $GLOBALS["goMap"]->zoompoint(1, $oPixelPos, $fWidthPix,
                        $fHeightPix, $oGeorefExt);
            }
            else if ($aVars["CMD"] == "ZOOM_FULL")
            {
                $GLOBALS["goMap"]->setextent($GLOBALS["gfMinX"],$GLOBALS["gfMinY"],
                                             $GLOBALS["gfMaxX"],$GLOBALS["gfMaxY"]);
            }
        }
    }
    else if (isset($aVars["KEYMAP_x"]) && isset($aVars["KEYMAP_y"]))
    {
      $oRefExt = $GLOBALS["goMap"]->reference->extent;
      
      $nX = intval($aVars["KEYMAP_x"]);
      $nY = intval($aVars["KEYMAP_y"]);
      
      $fWidthPix = doubleval($GLOBALS["goMap"]->reference->width);
      $fHeightPix = doubleval($GLOBALS["goMap"]->reference->height);
      
      $nGeoX = Pix2Geo($nX, 0, $fWidthPix, $oRefExt->minx, $oRefExt->maxx, 0);
      $nGeoY = Pix2Geo($nY, 0, $fHeightPix, $oRefExt->miny, $oRefExt->maxy, 1);
      
      $fDeltaX = ($fMaxX - $fMinX) / 2.0;
      $fDeltaY = ($fMaxY - $fMinY) / 2.0;
      
      $GLOBALS["goMap"]->setextent($nGeoX - $fDeltaX, $nGeoY - $fDeltaY,
                                   $nGeoX + $fDeltaX, $nGeoY + $fDeltaY);
    }

}   


function IsCurrentTool( $szTool )
{
    return (strcasecmp($GLOBALS["gszCurrentTool"], $szTool) == 0);
}


/*
 * Pix2Geo()
 * convert a pixel position to a geographic position
 *
 * nPixPos is the pixel position (x or y) to convert
 * dfPixMin, dfPixMax are the pixel extents to convert within (image size)
 * dfGeoMin, dfGeoMax are the geographic extents to convert with
 * bInversePix is true if the upper left corner is bigger than the
 *             lower right corner for y coordinates.
 */
function Pix2Geo($nPixPos, $fPixMin, $fPixMax, $fGeoMin, $fGeoMax,
                     $bInversePix)
{
    $fDeltaPix = ($bInversePix) ? $fPixMax - $nPixPos : $nPixPos - $fPixMin;

    $fDeltaGeo = $fDeltaPix * ($fGeoMax - $fGeoMin) / ($fPixMax - $fPixMin);

    return $fGeoMin + $fDeltaGeo;
}
